package Pod::PlainText;use strict;require 5.005;use Carp qw(carp croak);use Pod::Select ();use vars qw(@ISA %ESCAPES $VERSION);@ISA=qw(Pod::Select);$VERSION='2.07';BEGIN {if ($] < 5.006){require Symbol;import Symbol}}%ESCAPES=('amp'=>'&','lt'=>'<','gt'=>'>','quot'=>'"',"Aacute"=>"\xC1","aacute"=>"\xE1","Acirc"=>"\xC2","acirc"=>"\xE2","AElig"=>"\xC6","aelig"=>"\xE6","Agrave"=>"\xC0","agrave"=>"\xE0","Aring"=>"\xC5","aring"=>"\xE5","Atilde"=>"\xC3","atilde"=>"\xE3","Auml"=>"\xC4","auml"=>"\xE4","Ccedil"=>"\xC7","ccedil"=>"\xE7","Eacute"=>"\xC9","eacute"=>"\xE9","Ecirc"=>"\xCA","ecirc"=>"\xEA","Egrave"=>"\xC8","egrave"=>"\xE8","ETH"=>"\xD0","eth"=>"\xF0","Euml"=>"\xCB","euml"=>"\xEB","Iacute"=>"\xCD","iacute"=>"\xED","Icirc"=>"\xCE","icirc"=>"\xEE","Igrave"=>"\xCD","igrave"=>"\xED","Iuml"=>"\xCF","iuml"=>"\xEF","Ntilde"=>"\xD1","ntilde"=>"\xF1","Oacute"=>"\xD3","oacute"=>"\xF3","Ocirc"=>"\xD4","ocirc"=>"\xF4","Ograve"=>"\xD2","ograve"=>"\xF2","Oslash"=>"\xD8","oslash"=>"\xF8","Otilde"=>"\xD5","otilde"=>"\xF5","Ouml"=>"\xD6","ouml"=>"\xF6","szlig"=>"\xDF","THORN"=>"\xDE","thorn"=>"\xFE","Uacute"=>"\xDA","uacute"=>"\xFA","Ucirc"=>"\xDB","ucirc"=>"\xFB","Ugrave"=>"\xD9","ugrave"=>"\xF9","Uuml"=>"\xDC","uuml"=>"\xFC","Yacute"=>"\xDD","yacute"=>"\xFD","yuml"=>"\xFF","lchevron"=>"\xAB","rchevron"=>"\xBB",);sub initialize {my$self=shift;$$self{alt}=0 unless defined $$self{alt};$$self{indent}=4 unless defined $$self{indent};$$self{loose}=0 unless defined $$self{loose};$$self{sentence}=0 unless defined $$self{sentence};$$self{width}=76 unless defined $$self{width};$$self{INDENTS}=[];$$self{MARGIN}=$$self{indent};return$self->SUPER::initialize}sub command {my$self=shift;my$command=shift;return if$command eq 'pod';return if ($$self{EXCLUDE}&& $command ne 'end');if (defined $$self{ITEM}){$self->item ("\n");local $_="\n";$self->output($_)if($command eq 'back')}$command='cmd_' .$command;return$self->$command (@_)}sub verbatim {my$self=shift;return if $$self{EXCLUDE};$self->item if defined $$self{ITEM};local $_=shift;return if /^\s*$/;s/^(\s*\S+)/(' ' x $$self{MARGIN}) . $1/gme;return$self->output($_)}sub textblock {my$self=shift;return if $$self{EXCLUDE};if($$self{VERBATIM}){$self->output($_[0]);return}local $_=shift;my$line=shift;s{
        (
          L<                    # A link of the form L</something>.
              /
              (
                  [:\w]+        # The item has to be a simple word...
                  (\(\))?       # ...or simple function.
              )
          >
          (
              ,?\s+(and\s+)?    # Allow lots of them, conjuncted.
              L<  
                  /
                  (
                      [:\w]+
                      (\(\))?
                  )
              >
          )+
        )
    } {
        local $_ = $1;
        s%L</([^>]+)>%$1%g;
        my @items = split /(?:,?\s+(?:and\s+)?)/;
        my $string = "the ";
        my $i;
        for ($i = 0; $i < @items; $i++) {
            $string .= $items[$i];
            $string .= ", " if @items > 2 && $i != $#items;
            $string .= " and " if ($i == $#items - 1);
        }
        $string .= " entries elsewhere in this document";
        $string;
    }gex;$_=$self->interpolate ($_,$line);s/\s*$/\n/s;if (defined $$self{ITEM}){$self->item ($_ ."\n")}else {$self->output ($self->reformat ($_ ."\n"))}}sub interior_sequence {my$self=shift;my$command=shift;local $_=shift;return '' if ($command eq 'X' || $command eq 'Z');if ($command eq 'E'){return$ESCAPES{$_}if defined$ESCAPES{$_};carp "Unknown escape: E<$_>";return "E<$_>"}return if $_ eq '';if ($command eq 'S'){s/\s{2,}/ /g;tr/ /\01/;return $_}if ($command eq 'B'){return$self->seq_b ($_)}elsif ($command eq 'C'){return$self->seq_c ($_)}elsif ($command eq 'F'){return$self->seq_f ($_)}elsif ($command eq 'I'){return$self->seq_i ($_)}elsif ($command eq 'L'){return$self->seq_l ($_)}else {carp "Unknown sequence $command<$_>"}}sub preprocess_paragraph {my$self=shift;local $_=shift;1 while s/^(.*?)(\t+)/$1 . ' ' x (length ($2) * 8 - length ($1) % 8)/me;return $_}sub cmd_head1 {my$self=shift;local $_=shift;s/\s+$//s;$_=$self->interpolate ($_,shift);if ($$self{alt}){$self->output ("\n==== $_ ====\n\n")}else {$_ .= "\n" if $$self{loose};$self->output ($_ ."\n")}}sub cmd_head2 {my$self=shift;local $_=shift;s/\s+$//s;$_=$self->interpolate ($_,shift);if ($$self{alt}){$self->output ("\n==   $_   ==\n\n")}else {$_ .= "\n" if $$self{loose};$self->output (' ' x ($$self{indent}/ 2).$_ ."\n")}}sub cmd_head3 {my$self=shift;local $_=shift;s/\s+$//s;$_=$self->interpolate ($_,shift);if ($$self{alt}){$self->output ("\n= $_ =\n")}else {$_ .= "\n" if $$self{loose};$self->output (' ' x ($$self{indent}).$_ ."\n")}}*cmd_head4=\&cmd_head3;sub cmd_over {my$self=shift;local $_=shift;unless (/^[-+]?\d+\s+$/){$_=$$self{indent}}push (@{$$self{INDENTS}},$$self{MARGIN});$$self{MARGIN}+= ($_ + 0)}sub cmd_back {my$self=shift;$$self{MARGIN}=pop @{$$self{INDENTS}};unless (defined $$self{MARGIN}){carp 'Unmatched =back';$$self{MARGIN}=$$self{indent}}}sub cmd_item {my$self=shift;if (defined $$self{ITEM}){$self->item}local $_=shift;s/\s+$//s;$$self{ITEM}=$self->interpolate ($_)}sub cmd_begin {my$self=shift;local $_=shift;my ($kind)=/^(\S+)/ or return;if ($kind eq 'text'){$$self{VERBATIM}=1}else {$$self{EXCLUDE}=1}}sub cmd_end {my$self=shift;$$self{EXCLUDE}=0;$$self{VERBATIM}=0}sub cmd_for {my$self=shift;local $_=shift;my$line=shift;return unless s/^text\b[ \t]*\r?\n?//;$self->verbatim ($_,$line)}sub cmd_encoding {return}sub seq_b {return $_[0]{alt}? "``$_[1]''" : $_[1]}sub seq_c {return $_[0]{alt}? "``$_[1]''" : "`$_[1]'"}sub seq_f {return $_[0]{alt}? "\"$_[1]\"" : $_[1]}sub seq_i {return '*' .$_[1].'*'}sub seq_l {my$self=shift;local $_=shift;s/\s+/ /g;if (/^([^|]+)\|/){return $1}s/^\s+//;s/\s+$//;my ($manpage,$section)=('',$_);if (/^(?:https?|ftp|news):/){return $_}elsif (/^"\s*(.*?)\s*"$/){$section='"' .$1 .'"'}elsif (m/^[-:.\w]+(?:\(\S+\))?$/){($manpage,$section)=($_,'')}elsif (m{/}){($manpage,$section)=split (/\s*\/\s*/,$_,2)}my$text='';if (!length$section){$text="the $manpage manpage" if length$manpage}elsif ($section =~ /^[:\w]+(?:\(\))?/){$text .= 'the ' .$section .' entry';$text .= (length$manpage)? " in the $manpage manpage" : ' elsewhere in this document'}else {$section =~ s/^\"\s*//;$section =~ s/\s*\"$//;$text .= 'the section on "' .$section .'"';$text .= " in the $manpage manpage" if length$manpage}return$text}sub item {my$self=shift;local $_=shift;my$tag=$$self{ITEM};unless (defined$tag){carp 'item called without tag';return}undef $$self{ITEM};my$indent=$$self{INDENTS}[-1];unless (defined$indent){$indent=$$self{indent}}my$space=' ' x $indent;$space =~ s/^ /:/ if $$self{alt};if (!$_ || /^\s+$/ || ($$self{MARGIN}- $indent < length ($tag)+ 1)){my$margin=$$self{MARGIN};$$self{MARGIN}=$indent;my$output=$self->reformat ($tag);$output =~ s/[\r\n]*$/\n/;$self->output ($output);$$self{MARGIN}=$margin;$self->output ($self->reformat ($_))if /\S/}else {$_=$self->reformat ($_);s/^ /:/ if ($$self{alt}&& $indent > 0);my$tagspace=' ' x length$tag;s/^($space)$tagspace/$1$tag/ or carp 'Bizarre space in item';$self->output ($_)}}sub wrap {my$self=shift;local $_=shift;my$output='';my$spaces=' ' x $$self{MARGIN};my$width=$$self{width}- $$self{MARGIN};while (length > $width){if (s/^([^\r\n]{0,$width})\s+// || s/^([^\r\n]{$width})//){$output .= $spaces .$1 ."\n"}else {last}}$output .= $spaces .$_;$output =~ s/\s+$/\n\n/;return$output}sub reformat {my$self=shift;local $_=shift;if ($$self{sentence}){s/ +$//mg;s/\.\r?\n/. \n/g;s/[\r\n]+/ /g;s/   +/  /g}else {s/\s+/ /g}return$self->wrap($_)}sub output {$_[1]=~ tr/\01/ /;print {$_[0]->output_handle}$_[1]}sub pod2text {my@args;while ($_[0]=~ /^-/){my$flag=shift;if ($flag eq '-a'){push (@args,alt=>1)}elsif ($flag =~ /^-(\d+)$/){push (@args,width=>$1)}else {unshift (@_,$flag);last}}my$parser=Pod::PlainText->new (@args);if (defined $_[1]){my$infh;if ($] < 5.006){$infh=gensym()}unless (open ($infh,$_[0])){croak ("Can't open $_[0] for reading: $!\n")}$_[0]=$infh;return$parser->parse_from_filehandle (@_)}else {return$parser->parse_from_file (@_)}}1;